<html>

<head>

    <style>

        html {

        font-size: 16px;

        box-sizing: border-box;

        margin: 0;

        padding: 0;

        }

 

        ::before,

        ::after {

        box-sizing: inherit;

        }

 

        body {

        font-size: 1rem;

        }

 

        .container {

        max-width: 500px;

        margin: 2rem auto;

        border: 1px solid #ccc;

        padding: 1rem;

        }

 

        .input-group {

        position: relative;

        margin-bottom: 1rem;

        padding: 1rem 0;

        display: flex;

        justify-content: space-around;

        align-items: center;

        }

 

        .form-control {

        padding: .3rem;

        flex: 1;

        }

 

        .label {

        margin-right: 1rem;

        }

 

        .button {

        width: 100%;

        padding: .5rem;

        border: none;

        background-color: #121212;

        color: #fff;

        transition: all .3s;

        cursor: pointer;

        }

 

        .button:hover {

        background-color: #232323;

        }

 

        .tooltip {

        display: none;

        position: absolute;

        top: 15px;

        right: -150;

        min-width: 125px;

        max-width: 250px;

        background-color: #cb2431;

        color: #fff;

        padding: .5rem;

        font-size: .8rem;

        word-wrap: break-word;

        }

 

        .tooltip::before {

        content: '';

        position: absolute;

        left: -12px;

        top: 10px;

        width: 0;

        height: 0;

        background-color: transparent;

        border: 6px solid transparent;

        border-right-color: #cb2431;

        }

 

        .tooltip.show {

        display: block;

        }

        .message-error { color:  #cb2431; }

        @media screen and (max-width: 960px) {

            .tooltip {

                right: 0;

                top: -40px;

            }

        }

    </style>

</head>

<body>
    <div class="container">
        <form id="form" action="#" method="post">
            <div class="input-group">
                <label for="name" class="label">Name: </label>
                <input type="text" name="name" id="name" class="form-control">
                <span class="tooltip"></span>
            </div>
            
            <div class="input-group">
                <label for="email" class="label">Email: </label>
                <input type="text" name="email" id="email" class="form-control">
                <span class="tooltip"></span>
            </div>

            <div class="input-group">
                <input type="submit" class="button">
            </div>
            <p class="message-error" id="message-error"></a>
        </form>

    </div>

 

    <script>  
    
        /* FUNCIONES DE VALIDACIÓN */
        function validateForm(fields) {
            is_valid = true;
            fields.forEach((e) => {
                if (e.constructor === Object) {       
                     if ('field' in e && Object.getPrototypeOf(e.field.constructor) === HTMLElement && 'validations' in e) {                                  
                        for (let i = 0; i < e.validations.length; i++) {
                             if (!e.validations[i][0](e.field)) {
                                  // [NOTA]: 
                                 // SOLO FUNCIONA SI EL tootip se encuentra despues del 
                                 // input en el DOM. De otra forma debera asociarse un ID
                                 // o seleccionarlo aplicando DOM Traversing.
                                 e.field.nextElementSibling.innerHTML = e.validations[i][1];
                                 e.field.nextElementSibling.classList.add('show');
                                 is_valid = false;
                                 break;
                              }       
                         }                                                           
                      }                       
                  }
            }); 
            return is_valid;       
        }       
        
        
        function validate_required(field) {
            return field.value !== ''
        }
        
        function validate_email(field) {
            return RegExp('^[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,}$', 'i').test(field.value);
        }
        
       function hideTooltips() {
           const tooltips = Array.from(form.querySelectorAll('.tooltip'));
           tooltips.forEach((e) => {
               e.innerHTML = '';
               e.classList.remove('show');
           });
        };
            
        (function() {
            const form = document.getElementById('form');
            const inputs = Array.from(form.querySelectorAll('.form-control:not([type="submit"])'));

            form.addEventListener('submit', (e) => {
                e.preventDefault();
                hideTooltips();            
                
                const errorMessage = document.getElementById('message-error');
                errorMessage.innerHTML = '';
                
                // recupero los campos
                const name = document.getElementById('name');
                const email = document.getElementById('email');
                
                
                /* Configuración del array utilizado para realizar la validación de los campos        
                    ESTRUCTURA:
                                              
                    fields = [
                        {
                          field: <HTML_ELEMENT>
                          validations: [
                             [ <FUNCTION>, <MENSSAGE> ]
                          ]
                       }                        
                    ]
                                        
                */
                let fields = [
                    {
                        field: name,
                        validations: [
                            [validate_required, 'Campo Requerido']
                        ]
                    },
                    {
                        field: email, 
                        validations: [
                            [validate_required, 'Campo Requerido'], 
                            [validate_email, 'El email ingresado no es valido.'], 
                         ]
                    }
                ];
                

                // VALIDACION APLICADA A VARIOS CAMPOS
                let is_valid = validateForm(fields);
                
                if (!is_valid)
                    errorMessage.innerHTML = 'Comprueba los errores';
                else {
                    /*
                        En esta parte se realizá el envio del form, bien por el 
                        metodo submit() o vía Ajax.
                    */
                    alert('Enviado con exito');
                }                        
            });
        })();
    </script>
</bdoy>
</html>
